SNme1 = Core.class()

function SNme1:init(xtiny, xnmes) -- tiny function
	self.tiny = xtiny -- ref so we can remove entities from tiny system
	self.tiny.processingSystem(self) -- called once on init and every update
	self.nmes = xnmes
	-- sfx
	self.snd = Sound.new("audio/sfx/sfx_deathscream_human14.wav")
	self.channel = self.snd:play(0, false, true)
end

function SNme1:filter(ent) -- tiny function
	return ent.isnme
end

function SNme1:onAdd(ent) -- tiny function
end

function SNme1:onRemove(ent) -- tiny function
end

function SNme1:process(ent, dt) -- tiny function
	for i = #self.nmes, 1, -1 do -- scan in reverse
		if self.nmes[i].isdirty then -- hit
			self.channel = self.snd:play()
			if self.channel then self.channel:setVolume(0.3) end
			self.nmes[i].hitfx:setVisible(true)
			self.nmes[i].hitfx:setPosition(self.nmes[i].x+self.nmes[i].headhurtbox.x, self.nmes[i].y+self.nmes[i].headhurtbox.y)
			self.nmes[i].spritelayer:addChild(self.nmes[i].hitfx)
--			self.nmes[i].currhealth -= 1
			self.nmes[i].currhealth -= self.nmes[i].damage
			self.nmes[i].washurt = 30 -- timer for a flash effect
			self.nmes[i].sprite:setColorTransform(0, 0, 2, 3) -- the flash effect (a bright red color)
			self.nmes[i].isdirty = false
			if self.nmes[i].currhealth <= 0 then
--				self.nmes[i].hitfx:setVisible(false)
				self.nmes[i].hitfx:setColorTransform(3, 0, 0, 0.15)
				self.nmes[i].hitfx:setY(self.nmes[i].hitfx:getY()+16)
--				self.nmes[i].splatlayer:addChildAt(self.nmes[i].hitfx, 9) -- after the eighth building ;-)
				self.nmes[i].splatlayer:addChild(self.nmes[i].hitfx) -- after the eighth building ;-)
				self.tiny.tworld:removeEntity(self.nmes[i]) -- sprite is removed in SDrawable
				self.nmes[i] = nil
				table.remove(self.nmes, i)
			end
		end
	end
end
