ENme1 = Core.class()

function ENme1:init(xspritelayer, x, y, dx, dy, xsplatlayer, xbacklayer)
	-- ids
	self.isnme = true
	self.isactor = true
	-- sprite layer
	self.spritelayer = xspritelayer
	self.splatlayer = xsplatlayer
	self.backlayer = xbacklayer
	-- params
	self.x = x
	self.y = y
	self.sx = 1
	self.sy = self.sx
	self.flip = 1
	self.totallives = 3 -- 3
	self.currlives = self.totallives
	self.totalhealth = 3 -- 5
	self.currhealth = self.totalhealth
	self.washurt = 0
	self.punchtimer = math.random(20, 100)
	self.currpunchtimer = self.punchtimer
	self.hitfx = Bitmap.new(Texture.new("gfx/fx/1.png"))
	self.hitfx:setAnchorPoint(0.5, 0.5)
	-- ANIMATION COMPONENT
	local texpath = "gfx/player1/animeCharacter2b_0001.png"
	local framerate = 1/10 -- 20
	--function CAnimation:init(xspritesheetpath, xcols, xrows, xanimspeed, xoffx, xoffy, sx, sy)
	self.animation = CAnimation.new(texpath, 12, 7, framerate, 0, 0, self.sx, self.sy)
	self.sprite = self.animation.sprite
	self.sprite:setColorTransform(math.random(1, 5)/10, 0.9, 2, 2)
	self.animation.sprite = nil -- free some memory?
	self.w, self.h = self.sprite:getWidth(), self.sprite:getHeight()
--	self.w, self.h = self.animation.w, self.animation.h
	-- hurt box
	self.headhurtbox = {
		isactive=false,
		x=0,
		y=-self.h/4,
		w=self.w/3,
		h=self.h/3,
	}
	self.spinehurtbox = {
		isactive=false,
		x=-3,
		y=self.h/4-5,
		w=self.w/2,
		h=self.h/3,
	}
	-- hit box
	self.headhitbox = {
		isactive=false,
		x=0,
		y=0,
		w=0,
		h=0,
	}
	self.spinehitbox = {
		isactive=false,
		x=0,
		y=0,
		w=0,
		h=0,
	}
	-- create animations
	--function CAnimation:createAnim(xanimname, xstart, xfinish)
	self.animation:createAnim(g_ANIM_DEFAULT, 48, 71)
	self.animation:createAnim(g_ANIM_IDLE_L, 48, 71) -- L
	self.animation:createAnim(g_ANIM_IDLE_R, 48, 71) -- R
	self.animation:createAnim(g_ANIM_WALK_L, 1, 11)
	self.animation:createAnim(g_ANIM_WALK_R, 1, 11)
	self.animation:createAnim(g_ANIM_RUN_L, 36, 48)
	self.animation:createAnim(g_ANIM_RUN_R, 36, 48)
	self.animation:createAnim(g_ANIM_JUMPUP_L, 49, 69)
	self.animation:createAnim(g_ANIM_JUMPUP_R, 49, 69)
	self.animation:createAnim(g_ANIM_JUMPDOWN_L, 15, 25)
	self.animation:createAnim(g_ANIM_JUMPDOWN_R, 26, 36)
	self.animation:createAnim(g_ANIM_LADDERIDLE_L, 12, 14)
	self.animation:createAnim(g_ANIM_LADDERIDLE_R, 2, 4)
	self.animation:createAnim(g_ANIM_LADDERUP_L, 15, 25)
	self.animation:createAnim(g_ANIM_LADDERUP_R, 26, 36)
	self.animation:createAnim(g_ANIM_LADDERDOWN_L, 15, 25)
	self.animation:createAnim(g_ANIM_LADDERDOWN_R, 26, 36)
--	self.animation:createAnim(g_ANIM_LOSE1_R, 11, 19)
--	self.animation:createAnim(g_ANIM_STOMP_R, 21, 21)
--	self.animation:createAnim(g_ANIM_WIN_R, 11, 19)
	self.animation:createAnim(g_ANIM_ATTACK1_L, 12, 18)
	self.animation:createAnim(g_ANIM_ATTACK1_R, 12, 18)
	self.animation:createAnim(g_ANIM_ATTACK2_L, 19, 27)
	self.animation:createAnim(g_ANIM_ATTACK2_R, 19, 27)
	self.animation:createAnim(g_ANIM_ATTACK3_L, 72, 78)
	self.animation:createAnim(g_ANIM_ATTACK3_R, 72, 78)
	self.animation:createAnim(g_ANIM_JUMP_ATTACK1_L, 79, 84)
	self.animation:createAnim(g_ANIM_JUMP_ATTACK1_R, 79, 84)
	self.animation.myanimsimgs = nil -- free some memory?
	-- BODY COMPONENTS: function CBody:init(xspeed, xjumpspeed)
	self.body = CBody.new(3*16, 8*16) -- xspeed, xjumpspeed
	self.body.defaultmass = 1
	self.body.currmass = self.body.defaultmass
	-- AI COMPONENT: function CAI:init(x, y, dx, dy)
	self.ai = CAI.new(self.x, self.y, dx, dy)
	if self.ai.dx then self.isright = true end -- start moving our enemy1
	if self.ai.dy then self.isdown = true end -- start moving our enemy1
end
