EPlayer1 = Core.class()

function EPlayer1:init(xspritelayer, x, y, xsplatlayer, xbacklayer)
	-- ids
	self.isplayer1 = true
	self.isactor = true
	-- sprite layer
	self.spritelayer = xspritelayer
	self.splatlayer = xsplatlayer
	self.backlayer = xbacklayer
	-- params
	self.x = x
	self.y = y
	self.sx = 1
	self.sy = self.sx
	self.flip = 1
	self.totallives = 3 -- 3
	self.currlives = self.totallives
	self.totalhealth = 5000 -- 5
	self.currhealth = self.totalhealth
	self.ispaused = false -- for pausing the game
	self.hitfx = Bitmap.new(Texture.new("gfx/fx/2.png"))
	self.hitfx:setAnchorPoint(0.5, 0.5)
	-- ANIMATION COMPONENT
	local texpath = "gfx/player1/animeCharacter2b_0001.png"
	local framerate = 1/12 -- 20
	--function CAnimation:init(xspritesheetpath, xcols, xrows, xanimspeed, xoffx, xoffy, sx, sy)
	self.animation = CAnimation.new(texpath, 12, 7, framerate, 0, 0, self.sx, self.sy)
	self.sprite = self.animation.sprite
	self.animation.sprite = nil -- free some memory?
	self.w, self.h = self.sprite:getWidth(), self.sprite:getHeight()
	print("player1 original size: ", self.sprite:getWidth(), self.sprite:getHeight())
	print("player1 real size: ", self.sprite:getWidth()*self.sx, self.sprite:getHeight()*self.sy)
	-- hurt box
	self.headhurtbox = {
		isactive=false,
		x=-3,
		y=-self.h/4-5,
		w=self.w/3.2,
		h=self.h/3,
	}
	self.spinehurtbox = {
		isactive=false,
		x=-3,
		y=self.h/4-5,
		w=self.w/2,
		h=self.h/3,
	}
	-- hit box
	self.headhitbox = {
		isactive=false,
		x=0,
		y=0,
		w=0,
		h=0,
	}
	self.spinehitbox = {
		isactive=false,
		x=0,
		y=0,
		w=0,
		h=0,
	}
	-- create animations
	--function CAnimation:createAnim(xanimname, xstart, xfinish)
	self.animation:createAnim(g_ANIM_DEFAULT, 48, 71)
	self.animation:createAnim(g_ANIM_IDLE_L, 48, 71) -- L
	self.animation:createAnim(g_ANIM_IDLE_R, 48, 71) -- R
	self.animation:createAnim(g_ANIM_WALK_L, 1, 11)
	self.animation:createAnim(g_ANIM_WALK_R, 1, 11)
	self.animation:createAnim(g_ANIM_RUN_L, 36, 48)
	self.animation:createAnim(g_ANIM_RUN_R, 36, 48)
	self.animation:createAnim(g_ANIM_JUMPUP_L, 49, 69)
	self.animation:createAnim(g_ANIM_JUMPUP_R, 49, 69)
	self.animation:createAnim(g_ANIM_JUMPDOWN_L, 15, 25)
	self.animation:createAnim(g_ANIM_JUMPDOWN_R, 26, 36)
	self.animation:createAnim(g_ANIM_LADDERIDLE_L, 12, 14)
	self.animation:createAnim(g_ANIM_LADDERIDLE_R, 2, 4)
	self.animation:createAnim(g_ANIM_LADDERUP_L, 15, 25)
	self.animation:createAnim(g_ANIM_LADDERUP_R, 26, 36)
	self.animation:createAnim(g_ANIM_LADDERDOWN_L, 15, 25)
	self.animation:createAnim(g_ANIM_LADDERDOWN_R, 26, 36)
--	self.animation:createAnim(g_ANIM_LOSE1_R, 11, 19)
--	self.animation:createAnim(g_ANIM_STOMP_R, 21, 21)
--	self.animation:createAnim(g_ANIM_WIN_R, 11, 19)
	self.animation:createAnim(g_ANIM_ATTACK1_L, 12, 18)
	self.animation:createAnim(g_ANIM_ATTACK1_R, 12, 18)
	self.animation:createAnim(g_ANIM_ATTACK2_L, 19, 27)
	self.animation:createAnim(g_ANIM_ATTACK2_R, 19, 27)
	self.animation:createAnim(g_ANIM_ATTACK3_L, 72, 78)
	self.animation:createAnim(g_ANIM_ATTACK3_R, 72, 78)
	self.animation:createAnim(g_ANIM_JUMP_ATTACK1_L, 79, 84)
	self.animation:createAnim(g_ANIM_JUMP_ATTACK1_R, 79, 84)
	self.animation.myanimsimgs = nil -- free some memory?
	-- BODY COMPONENTS: function CBody:init(xspeed, xjumpspeed)
	self.body = CBody.new(6*16, 0.48) -- xspeed, xjumpspeed
	self.body.defaultmass = 1
	self.body.currmass = self.body.defaultmass
end
